<?php

class  TableGen
{
        var $irow       = - 1;
        var $icol       = 0;
        var $EchoOffset = 0;
        var $TableArray , $TableAtt , $TableCaption ;

        public function  gentable($TableId)
        {
                $VarTabletag = "
                <!--***************{$TableId}*****************-->
                <table {$this->TableArray['TableAttr']}>
                ";echo $VarTabletag;
                if (isset($this->TableCaption)) {
                        $VarCaption = "
                        <caption>{$this->TableCaption}</caption>"; echo $VarCaption;
                }

                for ($li = 0;$li <= $this->irow;$li++) {
                        if (!isset($this->TableArray['row'][$li]['RowAtt'])) $this->TableArray['row'][$li]['RowAtt'] = "" ;
                        echo "
                        <tr>
                        ";
                        $ncol = count($this->TableArray['row'][$li]["txt"]);
                        for ($ri = $this->EchoOffset;$ri < $ncol;$ri++) {
                                if (!isset($this->TableArray[$li]["DefaultAtt"])) $TextArray[$li]["DefaultAtt"] = "";
                                if (!isset($this->TableArray['row'][$li]["att"][$ri]))  $this->TableArray['row'][$li]["att"][$ri] = $this->TableArray['row'][$li]['RowAtt'];
                                if (!isset($this->TableArray['row'][$li]["txt"][$ri]))   $this->TableArray['row'][$li]["txt"][$ri] = "";
                                if ($li == 0) {
                                        $th = "
                                        <th scope='row' {$this->TableArray['row'][$li]["att"][$ri]} >{$this->TableArray['row'][$li]["txt"][$ri]}</th>";echo $th;
                                }
                                else {
                                        if ($ri == 0) {
                                                $th = "
                                                <th scope='row' {$this->TableArray['row'][$li]['att'][$ri]} >{$this->TableArray['row'][$li]['txt'][$ri]}</th>";echo $th;
                                        }

                                        else {
                                                $td = "
                                                <td {$this->TableArray['row'][$li]['att'][$ri]} >{$this->TableArray['row'][$li]['txt'][$ri]}</td>";echo $td;
                                        }
                                }

                        }
                        echo "
                        </tr>";
                }
                echo "
                </table>";
        }  // end of function

        public function AddTableAtt($att)
        {
                $this->TableArray['TableAttr'] = $att;
        }
        public function AddTableCaption($caption)
        {
                $this->TableCaption = $caption;
        }
        public function AddRow()
        {
                $this->irow++;  $this->icol = 0;  // zero the row pointer
        }
        public function AddRowAtt($att)
        {
                $this->TableArray['row'][$this->irow]['RowAtt'] = $att;
        }
        public function AddColumns($col)
        {
                $numargs = func_num_args();
                for ($i = 0;$i < $numargs;$i++) {
                        $this->TableArray['row'][$this->irow]['txt'][$this->icol] = func_get_arg($i);
                        $this->icol++;   //@ increnment tho col pointer
                }
        }
        public function AddColAtt($att)
        {
                $numargs = func_num_args();
                $ncol    = $numargs;
                $p       = $this->icol - $ncol;
                for ($i = 0;$i < $ncol;$i++) {
                        $this->TableArray['row'][$this->irow]['att'][$p] = func_get_arg($i);
                        $p++;   //@ increnment tho col pointer
                }
        }
        public function AddEchoOffset($offset)
        {
                $this->EchoOffset = $offset;
        }


        /*
        example ;
        $v = new TableGen;
        $v->AddTableAtt(' border="4" cellspacing="2" cellpadding="3"  align="right" dir="rtl"');
        $v->AddRow();$v->AddRowAtt(" class='hebrew_paragraph' height='18' ");
        $v->AddColumns("col1","col2");$v->AddColumns("col3","col4");
        $v->AddRow();
        $v->AddColumns("hhh1","hhh3","ggg","tttt"); $v->AddColAtt("class='header21'" , "class='header11'");
        $v->AddRow();
        $v->AddColumns("hhh4");$v->AddColumns("hhh5");$v->AddColumns("hhh4");$v->AddColumns("hhh5"); $v->AddColAtt("class='header21'" );

        $v->AddTableCaption("jjjjjjjj");

        $v->AddEchoOffset(0);  // the default is 0 and it means echo all columns, if required to print a subset of columns than increment it.
        $v->GenTable("id1");
        */
}

?>
